import pefile
import sys
import os

files = []


def print_usage():
    print("Utilização: python", os.path.basename(__file__), "<primeiro executável> <segundo executável>")


# Trata o input do usuário
def handle_input():
    try:
        if os.path.isfile(sys.argv[1]) & os.path.isfile(sys.argv[2]):
            files.append(os.path.realpath(sys.argv[1]))
            files.append(os.path.realpath(sys.argv[2]))
        else:
            print("Arquivos inválidos!")
            exit()
    except IndexError:
        print('ARQUIVOS NÃO INFORMADOS')
        print_usage()
    except FileNotFoundError:
        print('ARQUIVO NÃO ENCONTRADO')
        print_usage()


def print_common_sections():
    try:
        # Lê arquivos
        pe1 = pefile.PE(files[0])
        pe2 = pefile.PE(files[1])
        pe1sections = []
        pe2sections = []

        # Separa as seções
        for section in pe1.sections:
            pe1sections.append(section.Name.decode('utf-8').rstrip('\x00'))
        for section in pe2.sections:
            pe2sections.append(section.Name.decode('utf-8').rstrip('\x00'))

        # Utiliza sets para imprimir interseção e elementos exclusivos
        print('==========================\n\nSeções comuns aos arquivos\n\n==========================\n')
        print(list(set(pe1sections) & set(pe2sections)), '\n')
        print('=============================\n\nSeções exclusivas dos arquivos\n\n=============================\n')
        print(os.path.basename(files[0]) + ': ', list(set(pe1sections).difference(pe2sections)), '\n')
        print(os.path.basename(files[0]) + ': ', list(set(pe2sections).difference(pe1sections)), '\n')
    except pefile.PEFormatError:
        print("ARQUIVO INVÁLIDO!")
        print_usage()


if __name__ == '__main__':
    handle_input()
    print_common_sections()
