import pefile
import sys
import os

files = []


def print_usage():
    print("Utilização: python", os.path.basename(__file__), "<pasta com executáveis ou arquivo executável>")


# Trata o input do usuário
def handle_input():
    try:
        if os.path.isdir(sys.argv[1]):
            for file in os.listdir(sys.argv[1]):
                files.append(os.path.join(sys.argv[1], file))
        elif os.path.isfile(sys.argv[1]):
            files.append(os.path.realpath(sys.argv[1]))
    except IndexError:
        print("PARÂMETROS FALTANTES")
        print_usage()
    except FileNotFoundError:
        print("ARQUIVO NÃO ENCONTRADO")
        print_usage()


# Encontra as seções executáveis e imprime na saida padrão
def print_executable_sections():
    try:
        objeto = {}
        for file in files:
            pe = pefile.PE(file)
            executable = []
            for section in pe.sections:
                if section.IMAGE_SCN_MEM_EXECUTE:
                    executable.append(section.Name.decode('utf-8').rstrip('\x00'))
            objeto[os.path.basename(file)] = executable
        print(objeto)
    except pefile.PEFormatError:
        print('ARQUIVO INVÁLIDO!')
        if len(files) > 1:
            print("A pasta deve conter SOMENTE arquivos executáveis")
        print_usage()


if __name__ == '__main__':
    handle_input()
    print_executable_sections()
